"""Initial

Revision ID: a0dba36ff4da
Revises:
Create Date: 2021-05-27 12:04:25.031234+02:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_function import PGFunction
from sqlalchemy.dialects import postgresql
from sqlalchemy.schema import CreateSequence, Sequence

# revision identifiers, used by Alembic.
revision = "a0dba36ff4da"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # The next line is mannually added to make the sequence for the id
    op.execute(CreateSequence(Sequence("CallbackRequest_id_seq")))
    # ### commands auto generated by Alembic - please adjust! ###
    public_callbackrequest_generate_id = PGFunction(
        schema="public",
        signature="callbackrequest_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'TBV-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"CallbackRequest_id_seq\"') INTO value_numeric;\n                                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.create_entity(public_callbackrequest_generate_id)
    op.create_table(
        "CustomField",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.Column("required", sa.Boolean(), nullable=True),
        sa.Column(
            "type",
            postgresql.ENUM("string", "text", "select", name="customfieldtypes"),
            nullable=False,
        ),
        sa.Column("sort_order", sa.Integer(), nullable=False),
        sa.Column("options", sa.JSON(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_CustomField_name"), "CustomField", ["name"], unique=True)
    op.create_index(op.f("ix_CustomField_sid"), "CustomField", ["sid"], unique=False)
    op.create_index(
        op.f("ix_CustomField_sort_order"),
        "CustomField",
        ["sort_order"],
        unique=False,
    )
    op.create_table(
        "Employee",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("email", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_Employee_email"), "Employee", ["email"], unique=True)
    op.create_index(op.f("ix_Employee_name"), "Employee", ["name"], unique=True)
    op.create_index(op.f("ix_Employee_sid"), "Employee", ["sid"], unique=False)
    op.create_table(
        "Result",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("result", sa.String(), nullable=True),
        sa.Column("default", sa.Boolean(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_Result_result"), "Result", ["result"], unique=True)
    op.create_index(op.f("ix_Result_sid"), "Result", ["sid"], unique=False)
    op.create_table(
        "CallbackRequest",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "id",
            sa.String(),
            server_default=sa.text("callbackrequest_generate_id()"),
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("contact", sa.String(), nullable=True),
        sa.Column("subject", sa.String(), nullable=True),
        sa.Column("summary", sa.String(), nullable=True),
        sa.Column("phone", sa.String(), nullable=True),
        sa.Column(
            "status",
            postgresql.ENUM("Open", "Afgehandeld", name="statusses"),
            nullable=False,
        ),
        sa.Column("result_id", sa.Integer(), nullable=True),
        sa.Column("employee_id", sa.Integer(), nullable=True),
        sa.Column("created_at", sa.DateTime(), nullable=True),
        sa.Column("updated_at", sa.DateTime(), nullable=True),
        sa.ForeignKeyConstraint(
            ["employee_id"],
            ["Employee.sid"],
        ),
        sa.ForeignKeyConstraint(
            ["result_id"],
            ["Result.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(
        op.f("ix_CallbackRequest_contact"),
        "CallbackRequest",
        ["contact"],
        unique=False,
    )
    op.create_index(op.f("ix_CallbackRequest_id"), "CallbackRequest", ["id"], unique=True)
    op.create_index(
        op.f("ix_CallbackRequest_sid"),
        "CallbackRequest",
        ["sid"],
        unique=False,
    )
    op.create_table(
        "CustomFieldValues",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column("callback_request_id", sa.Integer(), nullable=True),
        sa.Column("custom_field_id", sa.Integer(), nullable=False),
        sa.Column("value", sa.String(), nullable=True),
        sa.ForeignKeyConstraint(
            ["callback_request_id"],
            ["CallbackRequest.sid"],
        ),
        sa.ForeignKeyConstraint(
            ["custom_field_id"],
            ["CustomField.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
    )
    op.create_index(
        op.f("ix_CustomFieldValues_callback_request_id"),
        "CustomFieldValues",
        ["callback_request_id"],
        unique=False,
    )
    op.create_index(
        op.f("ix_CustomFieldValues_sid"),
        "CustomFieldValues",
        ["sid"],
        unique=False,
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_CustomFieldValues_sid"), table_name="CustomFieldValues")
    op.drop_index(
        op.f("ix_CustomFieldValues_callback_request_id"),
        table_name="CustomFieldValues",
    )
    op.drop_table("CustomFieldValues")
    op.drop_index(op.f("ix_CallbackRequest_sid"), table_name="CallbackRequest")
    op.drop_index(op.f("ix_CallbackRequest_id"), table_name="CallbackRequest")
    op.drop_index(op.f("ix_CallbackRequest_contact"), table_name="CallbackRequest")
    op.drop_table("CallbackRequest")
    op.drop_index(op.f("ix_Result_sid"), table_name="Result")
    op.drop_index(op.f("ix_Result_result"), table_name="Result")
    op.drop_table("Result")
    op.drop_index(op.f("ix_Employee_sid"), table_name="Employee")
    op.drop_index(op.f("ix_Employee_name"), table_name="Employee")
    op.drop_index(op.f("ix_Employee_email"), table_name="Employee")
    op.drop_table("Employee")
    op.drop_index(op.f("ix_CustomField_sort_order"), table_name="CustomField")
    op.drop_index(op.f("ix_CustomField_sid"), table_name="CustomField")
    op.drop_index(op.f("ix_CustomField_name"), table_name="CustomField")
    op.drop_table("CustomField")
    public_callbackrequest_generate_id = PGFunction(
        schema="public",
        signature="callbackrequest_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'TBV-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"CallbackRequest_id_seq\"') INTO value_numeric;\n                                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.drop_entity(public_callbackrequest_generate_id)
    # ### end Alembic commands ###
